When creating a Consortium the following elements should be taken in consideration:

### Governance
Chosen structure must not only be appropriate to permit efficient and effective operations of the Consortium, 
but also fulfill the concerns of those that form part of it equally.

### Ownership
The nature of blockchain technology also increases the risk of accidental data exposure. In order to manage this risk
ownership of Intellectual Properties (IP), and assets should be documented, and agreed upon. 

### Liability
Most network operational activities are benign, but this is not true in all cases,
and even in otherwise low-risk Consortium, where the membership constitutes “market power” under the antitrust
laws, a significant percentage of the competitors in a given product or service space might be members. The potential
for inadvertent mistakes, as well as the level of potential scrutiny by government regulators, is higher.
In such a situation, individual members may wish to maintain tighter control over what can – and more importantly, what cannot – be done 
by the organization, and its members without proper prior consensus in order to reduce the risk and liability.

### Activities
Interconnecting multiple independent networks comes with risk factors. In order to
build a controls to minimize a risk, the activities that are expected to be performed in the network must be documented.  

### Security Checklist

!!! success "Use Byzantine fault tolerant consensus protocol in case nodes are managed by un-trusted participants"

!!! success "Consortium member should provide a reasonable network Service-Level Agreement (SLA)."

!!! success "Ensure Private/Public payloads data is stored in a appropiate Geographical legislation area. "

!!! success "Document the Consortium Governance Structure, Ownership, Liability, Memberships, Activities. "

!!! success "Document the Organizational, and technological requirements to join the Consortium. "

!!! success "Ensure Consortium members be known to every participant in the network."

!!! success "Ensure Private/Public paylaod data is compliant with privacy policies. "
