### Projections for 2018 / 2019


 
!!! abstract "Privacy" 

    - Organization-level privacy addressing
    - Asset Transfer with Privacy (ZKP)
    - Private Contract extensibility
    - Private State consensus (beyond exposing sync methods)


!!! abstract "Permissioning"

    - Support different role-types: Read vs Write nodes/accounts
    - Smart Contract-based network permissions
    - Authenticated / Protected RPC API access
    - Consensus Node Whitelisting

!!! abstract "Performance"

    - Performance benchmark guidelines
    - Transaction parallelization R&D
    - EVM optimizations
    - eWASM support

!!! abstract "Resiliency"

    - Transaction Manager clusters
    - Transaction Manager auto-recover of data in case of loss

!!! abstract "Scalability & Interoperability"

    - Raft scalability enhancements
    - POA & other consensus algorithms
    - Inter-quorum asset transfers
    - Rate limiting (gas price)

!!! abstract "Tooling"

    - One-click network deployments
    - Database adapters for better querying
    - Monitoring/Logging tools
    - Identity management tools

!!! abstract "Other / (Ongoing)"

    - Ensure EEA Specification compliance
    - Merge upstream geth changes
